#include <stdio.h>
#include <stdlib.h>

struct ttbl {
    int	moji;
    int	mzasc;
};
struct ttbl transtable[] = {
    { '', 0x1e },  { '', 0x1f },  { '', 0x1d },  { 'E', 0x1c },
    { 'g', 0x0b },  { 'b', 0x0c },  { '', 0x68 },  { '', 0x67 },
    { '', 0x70 },  { '', 0x71 },  { '', 0x72 },  { '', 0x73 },
    { '', 0x74 },  { '', 0x75 },  { 'y', 0x76 },  { '', 0x77 },
    { 'N', 0x78 },  { '', 0x79 },  { '', 0x7a },  { 'b', 0x7b },
    { '', 0x7d },  { '', 0x7e },  { '~', 0x7c },
    { '', 0x5e },  { '', 0x5f },  { '', 0xc0 },  { '', 0x80 },
    { 'B', 0x81 },  { 'u', 0x82 },  { 'v', 0x83 },  { 'A', 0x84 },  { 'D', 0x85 },
    { '', 0x86 },  
    { '@', 0x87 },  { 'B', 0x88 },  { 'D', 0x89 },  { 'F', 0x8a },  { 'H', 0x8b },
    { '', 0x8c },  { '', 0x8d },  { '', 0x8e },  { 'b', 0x8f },  { '[', 0x90 },
    { 'A', 0x91 },  { 'C', 0x92 },  { 'E', 0x93 },  { 'G', 0x94 },  { 'I', 0x95 },
    { 'J', 0x96 },  { 'L', 0x97 },  { 'N', 0x98 },  { 'P', 0x99 },  { 'R', 0x9a },
    { 'T', 0x9b },  { 'V', 0x9c },  { 'X', 0x9d },  { 'Z', 0x9e },  { '\', 0x9f },
    { '^', 0xa0 },  { '`', 0xa1 },  { 'c', 0xa2 },  { 'e', 0xa3 },  { 'g', 0xa4 },
    { 'i', 0xa5 },  { 'j', 0xa6 },  { 'k', 0xa7 },  { 'l', 0xa8 },  { 'm', 0xa9 },
    { 'n', 0xaa },  { 'q', 0xab },  { 't', 0xac },  { 'w', 0xad },  { 'z', 0xae },
    { '}', 0xaf },  { '~', 0xb0 },  { '', 0xb1 },  { '', 0xb2 },  { '', 0xb3 },
    { '', 0xb4 },  { '', 0xb5 },  { '', 0xb6 },
    { '', 0xb7 },  { '', 0xb8 },  { '', 0xb9 },  { '', 0xba },  { '', 0xbb },
    { '', 0xbc },  { '', 0xbd },  { 'J', 0xbe },  { 'K', 0xbf },
    { 'K', 0x196 },  { 'M', 0x197 },  { 'O', 0x198 },  { 'Q', 0x199 },  { 'S', 0x19a },
    { 'U', 0x19b },  { 'W', 0x19c },  { 'Y', 0x19d },  { '[', 0x19e },  { ']', 0x19f },
    { '_', 0x1a0 },  { 'a', 0x1a1 },  { 'd', 0x1a2 },  { 'f', 0x1a3 },  { 'h', 0x1a4 },
    { 'o', 0x1aa },  { 'r', 0x1ab },  { 'u', 0x1ac },  { 'x', 0x1ad },  { '{', 0x1ae },
    { 'p', 0x2aa },  { 's', 0x2ab },  { 'v', 0x2ac },  { 'y', 0x2ad },  { '|', 0x2ae },
    { '', 0x86 },  
    { '', 0x87 },  { '', 0x88 },  { '', 0x89 },  { '', 0x8a },  { '', 0x8b },
    { '', 0x8c },  { '', 0x8d },  { '', 0x8e },  { '', 0x8f },
    { '', 0x91 },  { '', 0x92 },  { '', 0x93 },  { '', 0x94 },  { '', 0x95 },
    { '', 0x96 },  { '', 0x97 },  { '', 0x98 },  { '', 0x99 },  { '', 0x9a },
    { '', 0x9b },  { '', 0x9c },  { '', 0x9d },  { '', 0x9e },  { '', 0x9f },
    { '', 0xa0 },  { '', 0xa1 },  { '', 0xa2 },  { '', 0xa3 },  { '', 0xa4 },
    { '', 0xa5 },  { '', 0xa6 },  { '', 0xa7 },  { '', 0xa8 },  { '', 0xa9 },
    { '', 0xaa },  { '', 0xab },  { '', 0xac },  { '', 0xad },  { '', 0xae },
    { '', 0xaf },  { '', 0xb0 },  { '', 0xb1 },  { '', 0xb2 },  { '', 0xb3 },
    { '', 0xb4 },  { '', 0xb5 },  { '', 0xb6 },
    { '', 0xb7 },  { '', 0xb8 },  { '', 0xb9 },  { '', 0xba },  { '', 0xbb },
    { '', 0xbc },  { '', 0xbd },
    { '', 0x196 },  { '', 0x197 },  { '', 0x198 },  { '', 0x199 },  { '', 0x19a },
    { '', 0x19b },  { '', 0x19c },  { '', 0x19d },  { '', 0x19e },  { '', 0x19f },
    { '', 0x1a0 },  { '', 0x1a1 },  { '', 0x1a2 },  { '', 0x1a3 },  { '', 0x1a4 },
    { '', 0x1aa },  { '', 0x1ab },  { '', 0x1ac },  { '', 0x1ad },  { '', 0x1ae },
    { '', 0x2aa },  { '', 0x2ab },  { '', 0x2ac },  { '', 0x2ad },  { '', 0x2ae },
    { '', 0xcb },  { '', 0xcd },  { '', 0xce },  { '', 0xd0 },  { '', 0xd1 },
    { '', 0xd2 },  { '', 0xd3 },  { '', 0xdd },  { '', 0xe0 },  { '', 0xe2 },
    { '', 0xfb },  { '~', 0xf6 },  { '_', 0xed },  { '^', 0xee },
    { '', 0xf1 },  { '', 0xf7 },  { '', 0xfa },  { '', 0xc8 },
    { '', 0xff },
    { 0, 0 }
};

unsigned char mem[65536];

int main(int argc, char **argv) {
    FILE *fp;
    unsigned char buf[2048];
    unsigned char *p;
    char *fn, *s;
    int siz, fsiz, len, line;
    int blocksize = 256;

    fn = NULL;

    if (argc == 2) {
	fn = argv[1];
    } else if (argc == 3) {
	s = argv[1];
	fn = argv[2];
	if (s[0] == '-' && s[1] == 's') {
	    blocksize = 1024;
	} else if (s[0] == '-' && s[1] == 'h') {
	    blocksize = 256;
	} else {
	    fn = NULL;
	}
    }

    if (fn == NULL) {
	fprintf(stderr, "Usage: TXT2MZT [option] <filename>\n"
			"  Convert a Shift-JIS text to ASCII-saved MZT format\n"
			"  Option:\n"
			"    -s  Convert for S-BASIC / 5Z-001\n"
			"    -h  Convert for Hu-BASIC\n");
	return -1;
    }

    fp = fopen(fn, "rb");
    if (fp == NULL) {
	fprintf(stderr, "File not found\n");
	return -1;
    }

    mem[0] = (blocksize == 256) ? 0x04 : 0x03;
    /*		      0123456789ABCDEF0	*/
    sprintf(&mem[1], "A                ");
    if (blocksize == 1024) mem[2] = 0x0d;

    p = &mem[128];
    *p++ = 0xff;
    *p++ = 0xff;
    siz = blocksize;
    fsiz = 128 + blocksize + 2;
    line = 0;
    while (fgets(buf, 2048, fp) != NULL) {
	unsigned char c, *q;
	
	q = buf;
	line++;
	len = 0;
	while ((c = *q++) != 0) {
	    if (c < 0x20) {
		continue;
	    } else if (c >= 0x20 && c <= 0x5d) {
		*p++ = c;
		len++;
		if (--siz == 0) {
		    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
		    *p++ = 0xff;  *p++ = 0xff;
		    siz = blocksize;    fsiz += blocksize + 2;
		}
	    } else if (c >= 'a' && c <= 'z') {
		*p++ = c - 'a' + 'A';
		len++;
		if (--siz == 0) {
		    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
		    *p++ = 0xff;  *p++ = 0xff;
		    siz = blocksize;    fsiz += blocksize + 2;
		}
	    } else {
		int i, j;
		struct ttbl *t;
		if (((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc)) && (*q != 0)) {
		    i = ((int)c << 8) + (int)(*q++);
//		    i = (int)c + (int)((*q++) << 8);
		} else {
		    i = (int)c;
		}
		for (j=0, t = &transtable[0]; t->moji; j++, t++) {
		    if (t->moji == i) {
			int k;
			k = t->mzasc;
			switch (k >> 8) {
			    case 0:
				*p++ = k;
				len++;
				if (--siz == 0) {
				    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
				    *p++ = 0xff;  *p++ = 0xff;
				    siz = blocksize;    fsiz += blocksize + 2;
				}
				break;
			    case 1:
				*p++ = (k & 0xff);
				len++;
				if (--siz == 0) {
				    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
				    *p++ = 0xff;  *p++ = 0xff;
				    siz = blocksize;    fsiz += blocksize + 2;
				}
				*p++ = 0xbe;
				len++;
				if (--siz == 0) {
				    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
				    *p++ = 0xff;  *p++ = 0xff;
				    siz = blocksize;    fsiz += blocksize + 2;
				}
				break;
			    case 2:
				*p++ = (k & 0xff);
				len++;
				if (--siz == 0) {
				    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
				    *p++ = 0xff;  *p++ = 0xff;
				    siz = blocksize;    fsiz += blocksize + 2;
				}
				*p++ = 0xbf;
				len++;
				if (--siz == 0) {
				    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
				    *p++ = 0xff;  *p++ = 0xff;
				    siz = blocksize;    fsiz += blocksize + 2;
				}
				break;
			    default:
				break;
			}
			break;
		    }
		}
	    }
	}
	*p++ = 0x0d;
	if (len > 255) {
	    fprintf(stdout, "%5d: 1s̕255𒴂Ă܂(+%d)\n", line, len-255);
	    fclose(fp);
	    return -1;
	}
	if (--siz == 0) {
	    p[- blocksize - 2] = 0;  p[- blocksize - 1] = 0;
	    *p++ = 0xff;  *p++ = 0xff;
	    siz = blocksize;    fsiz += blocksize + 2;
	}
    }
    fclose(fp);
    *p = 0x1a;

    mem[0x12] = (fsiz - 128) & 0x00FF;
    mem[0x13] = (fsiz - 128) >> 8;

    fp = fopen("OUT.MZT", "wb");
    fwrite(mem, 1, fsiz, fp);
    fclose(fp);
    fprintf(stdout, "OUT.MZTo͂܂\n");

    return 0;
}
